import { defineComponent, ref, watch } from 'vue';
import styles from './index.module.less';
import { useUserStore } from '/src/store/modules/users';
import { vaildMusicScoreUrl } from '/src/utils/urlUtils';

export default defineComponent({
  name: 'song-modal',
  props: {
    item: {
      type: Object,
      default: () => ({})
    },
    activeStatus: {
      type: Boolean,
      default: false
    }
  },
  emits: ['setIframe'],
  setup(props, { emit }) {
    const userStore = useUserStore();
    const iframeRef = ref();
    const isLoaded = ref(false);

    // const src = `${vaildMusicScoreUrl()}/instrument/#/view-figner?Authorization=${
    //   userStore.getToken
    // }&code=${item.code}&platform=pc&type=listenMode`;
    // // const src = `http://192.168.3.220:3000/instrument.html#/view-figner?Authorization=${userStore.getToken}&code=${item.code}`;
    // if (window.matchMedia('(display-mode: standalone)').matches) {
    //   state.application = window.matchMedia(
    //     '(display-mode: standalone)'
    //   ).matches;
    //   forms.previewModal = true;
    //   forms.previewParams.src = src + '&matchMedia=1';
    // } else {
    //   window.open(src);
    // }

    const src = `${vaildMusicScoreUrl()}/instrument/#/view-figner?Authorization=${
      userStore.getToken
    }&code=${props.item.content}&platform=pc&type=listenMode`;
    // if (/(localhost|192)/.test(location.host)) {
    //   src = `http://localhost:9002/#/tempo-practice?v=${Date.now()}&Authorization=${
    //     userStore.getToken
    //   }&platform=modal`;
    // }

    watch(
      () => props.activeStatus,
      () => {
        if (!props.activeStatus) {
          iframeRef.value.contentWindow?.postMessage({ api: 'resetPlay' }, '*');
        }
      }
    );
    return () => (
      <div class={styles.musicScore}>
        <iframe
          ref={iframeRef}
          onLoad={() => {
            emit('setIframe', iframeRef.value);
            isLoaded.value = true;
          }}
          class={[styles.container, 'musicIframe']}
          frameborder="0"
          src={src}></iframe>
      </div>
    );
  }
});
